//+------------------------------------------------------------------+
//|                                                          RVI.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  OrangeRed

//
//
//
//
//

extern int  RVIPeriod       = 10;
extern int  SmoothPeriod    = 4;
extern int  SignalPeriod    = 4;

//
//
//
//
//

double RVIBuffer[];
double RVISignalBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,RVIBuffer);       SetIndexLabel(0,"RVI"); 
   SetIndexBuffer(1,RVISignalBuffer); SetIndexLabel(1,"RVI Signal");
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("RVI ("+RVIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];
#define _co 0
#define _hl 1

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_co] = iTma(Close[i]-Open[i],SmoothPeriod,i,0);
      work[r][_hl] = iTma(High[i]-Low[i]  ,SmoothPeriod,i,1);
      
      //
      //
      //
      //
      //
      
      double sumco = 0.0; 
      double sumhl = 0.0;
         for(int k=0; k<RVIPeriod && (r-k)>=0; k++)
         {
            sumco += work[r-k][_co];
            sumhl += work[r-k][_hl];
         }
         if(sumhl!=0.0)
               RVIBuffer[i] = sumco/sumhl;
         else  RVIBuffer[i] = 0.0;
         RVISignalBuffer[i] = iTma(RVIBuffer[i],SignalPeriod,i,2);
   }

   //
   //
   //
   //
   //
      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workTma[][3];
double iTma(double price, double period, int r, int instanceNo=0)
{
   if (ArraySize(workTma)!= Bars) ArrayResize(workTma,Bars); r=Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workTma[r][instanceNo] = price;

      double half = (period+1.0)/2.0;
      double sum  = price;
      double sumw = 1;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = k+1; if (weight > half) weight = period-k;
                sumw  += weight;
                sum   += weight*workTma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

